require 'boid'

math.randomseed(os.time())

function love.load()
	s = Simulation(100, 800)
	
	love.graphics.setBackgroundColor(255, 255, 255)
	love.graphics.setColor(0, 0, 0)
	
	rotx = 0
	roty = 0
end

local cos, sin = math.cos, math.sin
function rotate(x, y, z, rotx, roty)
	local ry_x = cos(rotx) * x + sin(rotx) * z
	local ry_y = y
	local ry_z = -sin(rotx) * x + cos(rotx) * z
	local rx_x = ry_x
	local rx_y = cos(roty) * ry_y - sin(roty) * ry_z
	local rx_z = sin(roty) * ry_y + cos(roty) * ry_z
	return rx_x, rx_y, rx_z
end

function drawboid(b, rotx, roty)
	local x = b.pos.x
	local y = b.pos.y
	local z = b.pos.z
	x, y, z = rotate(x, y, z, rotx, roty)
	local s = 2.5 - z/400*1.5 --8/(430+z) + 2
	local norm = b.vel / b.vel:distance(Vel())
	norm.x, norm.y, norm.z = rotate(norm.x, norm.y, norm.z, rotx, roty)
	local n = math.sqrt(b.vel.x^2 + b.vel.y^2)
	local nx = b.vel.x / n
	local ny = b.vel.y / n

	love.graphics.setColor(64 * norm.z + 64, 64 * norm.z + 64, 64 * norm.z + 64)

	--love.graphics.circle('fill', x, y, s / 1.1, 30)
	
--	love.graphics.circle('fill', x + norm.x * 10, y + norm.y * 10, 1, 30)
	love.graphics.triangle('fill', x + norm.x * 5 * s, y + norm.y * 5 * s, x - ny * s, y + nx * s, x + ny * s, y - nx * s)
end

function love.update(dt)
	if love.mouse.isDown('l') then
		local x, y = love.mouse.getPosition()
		if X then
			rotx = rotx - (x - X) / 400
			roty = math.min(math.max(roty + (y - Y) / 400, 0), math.pi * .5)
		end
		X = x
		Y = y
	else
		X = nil
	end
--[[
	local x, y = love.mouse.getPosition()
	rotx = -math.pi * (x - 400) / 400
	roty = math.pi * .5 * math.max(y - 400, 0) / 400
]]
--[[	if love.keyboard.isDown'left' then
		rotx = rotx - dt
	elseif love.keyboard.isDown'right' then
		rotx = rotx + dt
	end
	if love.keyboard.isDown'up' then
		roty = math.min(roty + dt, math.pi * .5)
	elseif love.keyboard.isDown'down' then
		roty = math.max(roty - dt, 0)
	end]]
	s:step()
	love.timer.sleep(1)
end

local x1, z1 = -400, -400
local x2, z2 = 400, -400
local x3, z3 = 400, 400
local x4, z4 = -400, 400

function love.draw()
	love.graphics.push()
	love.graphics.translate(400, 400)
	local x1, y1 = rotate(-400, 400, -400, rotx, roty)
	local x2, y2 = rotate( 400, 400, -400, rotx, roty)
	local x3, y3 = rotate( 400, 400,  400, rotx, roty)
	local x4, y4 = rotate(-400, 400,  400, rotx, roty)
	love.graphics.setColor(0, 0, 255, 25)
	love.graphics.polygon('fill', x1, y1, x2, y2, x3, y3, x4, y4)
	for _,b in ipairs(s.boids) do
		drawboid(b, rotx, roty)
	end
	love.graphics.pop()
end
